// Add this to the css file:
// ---------------------------
// .ourTooltip > * {
//   background: #eee;
//   box-shadow: 0 0 5px #999999;
//   color: #333;
//   display: none;
//   font-size: 12px;
//   position: fixed;
//   text-align: center;
//   width: 50px;
//   left: 0;
//   /*z-index: 25;*/
//   opacity: 0.8;
// }
//-----------------------------


// [d] is the data that will be displayed in the ourTooltip.
// [display] is an array of keys that are pulled from [d].
// [box] is the DOM element that the ourTooltip will be attached to.
// No parameters passed will remove the ourTooltip
// 1 parameter passed will create the ourTooltip at the mouse location with [d] as
//  the information.
// 2 parameters passed will create the ourTooltip at the mouse location with
//  [d.display] as the accessors.
// 3 parameters passed will create the ourTooltip at the [box] bottom right location
//  with [d.display] as the accessors.
var ourTooltip = function (d, display, box){
	var width = '100%';
	var selection;

	ourTooltip.width = function(x){
		width = x;
		return ourTooltip;
	};

	if( arguments.length === 0 ){
		d3.selectAll('.ourTooltip').remove();
		return;
	}
	else if (arguments.length === 1){
		d3.select('body').append('path').attr("class", "ourTooltip").attr('width', width);
		selection = d3.select('.ourTooltip').append('div').attr("class", 'ourTooltipDiv').attr('width', width).html(d);
		selection.style('display', 'block')
			.style('top', (d3.event.pageY) + 'px')
			.style('left', (d3.event.pageX) + 'px')
			.style("opacity", 0)
			.transition().delay(250).duration(250).style('opacity', 1);
	}
	else if ( arguments.length === 2){
		d3.select('body').append('path').attr("class", "ourTooltip").attr('width', width);
		selection = d3.select('.ourTooltip').append('div').attr("class", 'ourTooltipDiv').attr('width', width);
		display.forEach(function(x,i){
		selection.append('div').html(x + d[i]);
		});
		selection.style('display', 'block')
			.style('top', (d3.event.pageY) + 'px')
			.style('left', (d3.event.pageX) + 'px')
			.style("opacity", 0)
			.style("position","absolute")
			.transition().delay(250).duration(250).style('opacity', 1);
	}
	else{
		d3.select('body').append('path').attr("class", "ourTooltip").attr('width', width);
		selection = d3.select('.ourTooltip').append('div').attr("class", 'ourTooltipDiv').attr('width', width);
		display.forEach(function(x,i){
		//console.log(d);
		selection.append('div').html(x + d[i]);
		});
		selection.style('display', 'block')
			.style('top', box.getBoundingClientRect().bottom + 'px')
			.style('left', box.getBoundingClientRect().right + 'px')
			.style("opacity", 0)
			.transition().delay(250).duration(250).style('opacity', 1);

	}
	return selection;
};
